"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactDraggable = require("react-draggable");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("./utils");

var DraggableChild =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(DraggableChild, _React$Component);

  function DraggableChild(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DraggableChild);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(DraggableChild).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "compareCoordinates", function (firstCoords, secondCoords) {
      return firstCoords.x !== secondCoords.x || firstCoords.y !== secondCoords.y;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleStart", function (ev, b) {
      var _this$state = _this.state,
          x = _this$state.x,
          y = _this$state.y;
      _this.lastX = (0, _utils.canDragX)(_this.props.axis) ? b.lastX - x : x;
      _this.lastY = (0, _utils.canDragY)(_this.props.axis) ? b.lastY - y : y;

      _this.props._start();

      _this.props.onStart(ev, (0, _utils.createCoreData)(b, {
        x: x,
        y: y
      }));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleDrag", function (ev, b) {
      var dragX = (0, _utils.canDragX)(_this.props.axis) ? b.lastX - _this.lastX : _this.lastX;
      var dragY = (0, _utils.canDragY)(_this.props.axis) ? b.lastY - _this.lastY : _this.lastY;

      var _this$props$_drag = _this.props._drag(dragX, dragY),
          x = _this$props$_drag.x,
          y = _this$props$_drag.y;

      _this.setState({
        x: x,
        y: y
      });

      _this.props.onDrag(ev, (0, _utils.createCoreData)(b, {
        originX: dragX,
        originY: dragY,
        x: x,
        y: y
      }));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleStop", function (ev, b) {
      var _this$state2 = _this.state,
          x = _this$state2.x,
          y = _this$state2.y;

      _this.props._stop();

      _this.props.onStop(ev, (0, _utils.createCoreData)(b, {
        x: x,
        y: y
      }));
    });
    _this.state = {
      x: props.defaultPosition.x,
      y: props.defaultPosition.y
    };
    _this.x = props.defaultPosition.x;
    _this.y = props.defaultPosition.y;
    return _this;
  }

  (0, _createClass2.default)(DraggableChild, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return this.compareCoordinates(this.props.defaultPosition, nextProps.defaultPosition) || this.compareCoordinates(this.state, nextState) || this.props.active !== nextProps.active;
    }
  }, {
    key: "render",
    value: function render() {
      var _React$cloneElement;

      var _this$state3 = this.state,
          x = _this$state3.x,
          y = _this$state3.y;
      var _this$props = this.props,
          active = _this$props.active,
          children = _this$props.children,
          activeClassName = _this$props.activeClassName,
          grid = _this$props.grid;
      var style = (0, _objectSpread2.default)({}, children.props.style, {
        position: 'absolute',
        top: y,
        left: x
      });
      var className = (0, _classnames.default)(children.props.className, (0, _defineProperty2.default)({}, activeClassName, active));
      return _react.default.createElement(_reactDraggable.DraggableCore, {
        grid: grid,
        onDrag: this.handleDrag,
        onStop: this.handleStop,
        onStart: this.handleStart,
        position: {
          x: x,
          y: y
        }
      }, _react.default.cloneElement(this.props.children, (_React$cloneElement = {
        style: style,
        className: className
      }, (0, _defineProperty2.default)(_React$cloneElement, 'data-x', x), (0, _defineProperty2.default)(_React$cloneElement, 'data-y', y), _React$cloneElement)));
    }
  }]);
  return DraggableChild;
}(_react.default.Component);

exports.default = DraggableChild;
(0, _defineProperty2.default)(DraggableChild, "propTypes", {
  children: _propTypes.default.element.isRequired,
  defaultPosition: _propTypes.default.object,
  onStart: _propTypes.default.func,
  onDrag: _propTypes.default.func,
  onStop: _propTypes.default.func,
  axis: _propTypes.default.oneOf(['both', 'x', 'y']),
  grid: _propTypes.default.object
});
(0, _defineProperty2.default)(DraggableChild, "defaultProps", {
  axis: 'both',
  defaultPosition: {
    x: 0,
    y: 0
  },
  onStart: _utils.noop,
  onDrag: _utils.noop,
  onStop: _utils.noop,
  grid: [1, 1]
});