"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.array.is-array");

require("core-js/modules/es6.number.max-safe-integer");

require("core-js/modules/es6.array.sort");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es7.object.entries");

require("core-js/modules/es7.array.includes");

require("core-js/modules/es6.string.includes");

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

require("core-js/modules/es6.array.find");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.for-each");

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.number.constructor");

require("core-js/modules/es6.array.map");

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("./utils");

var _lodash = _interopRequireDefault(require("lodash.isequal"));

var DraggableContainer =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(DraggableContainer, _React$Component);

  // container HTMLElement
  // children HTMLElement
  function DraggableContainer(props) {
    var _this;

    (0, _classCallCheck2.default)(this, DraggableContainer);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(DraggableContainer).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "$", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "$children", []);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "lastXpostion", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "lastYpostion", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "initialize", function () {
      _this.$children = _this.props.children.map(function (child, i) {
        var $ = _this.$.childNodes[i];
        var x = Number($.getAttribute('data-x'));
        var y = Number($.getAttribute('data-y'));
        var w = $.clientWidth;
        var h = $.clientHeight;
        return {
          $: $,
          i: i,
          x: x,
          y: y,
          w: w,
          h: h,
          l: x,
          r: x + w,
          t: y,
          b: y + h,
          lr: x + w / 2,
          tb: y + h / 2
        };
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "reset", function () {
      _this.setState({
        vLines: [],
        hLines: [],
        indices: []
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "calc", function (index) {
      return function (x, y) {
        var target = _this.$children[index];

        var compares = _this.$children.filter(function (_, i) {
          return i !== index;
        });

        if (_this.props.limit) {
          var _this$checkDragOut = _this.checkDragOut({
            x: x,
            y: y
          }, target),
              limitX = _this$checkDragOut.limitX,
              limitY = _this$checkDragOut.limitY;

          x = limitX;
          y = limitY;
        }

        if (_this.props.detectOverlap) {
          if (_this.checkOverlap({
            x: x,
            y: y
          }, target)) {
            if (_this.lastXpostion === null) {
              _this.lastXpostion = x;
              _this.lastYpostion = y;
            }

            return {
              x: _this.lastXpostion,
              y: _this.lastYpostion
            };
          }
        }

        _this.lastXpostion = null;
        _this.lastYpostion = null;

        if (compares.length === 0) {
          return {
            x: x,
            y: y
          };
        }

        return _this.calcAndDrawLines({
          x: x,
          y: y
        }, target, compares);
      };
    });
    _this.state = {
      indices: [],
      vLines: [],
      hLines: []
    };
    return _this;
  }

  (0, _createClass2.default)(DraggableContainer, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _lodash.default)(this.state, nextState) || !(0, _lodash.default)(this.props, nextProps);
    } // 拖拽初始时 计算出所有元素的坐标信息，存储于this.$children
    // The coordinate information of all elements is calculated at the beginning of dragging and stored in this.$children

  }, {
    key: "checkOverlap",
    value: function checkOverlap(_ref, target) {
      var x = _ref.x,
          y = _ref.y;

      for (var i = 0; i < this.$children.length; i += 1) {
        if (i === target.i) continue;
        if ((0, _utils.checkOverlapRectangles)((0, _objectSpread2.default)({}, target, {
          x: x,
          y: y
        }), this.$children[i])) return true;
      }

      return false;
    }
    /**
     * @param {Object} values xy坐标
     * @param {Object} target 拖拽目标
     * @param {Array} compares 对照组
     */

  }, {
    key: "calcAndDrawLines",
    value: function calcAndDrawLines(values, target, compares) {
      var _this2 = this;

      var _this$calcPosValues = this.calcPosValues(values, target, compares, 'x'),
          x = _this$calcPosValues.v,
          indices_x = _this$calcPosValues.indices,
          vLines = _this$calcPosValues.lines;

      var _this$calcPosValues2 = this.calcPosValues(values, target, compares, 'y'),
          y = _this$calcPosValues2.v,
          indices_y = _this$calcPosValues2.indices,
          hLines = _this$calcPosValues2.lines;

      var indices = (0, _utils.unique)(indices_x.concat(indices_y)); // https://github.com/zcued/react-dragline/issues/9

      if (vLines.length && hLines.length) {
        vLines.forEach(function (line) {
          var compare = compares.find(function (_ref2) {
            var i = _ref2.i;
            return i === line.i;
          });

          var _this2$calcLineValues = _this2.calcLineValues({
            x: x,
            y: y
          }, target, compare, 'x'),
              length = _this2$calcLineValues.length,
              origin = _this2$calcLineValues.origin;

          line.length = length;
          line.origin = origin;
        });
        hLines.forEach(function (line) {
          var compare = compares.find(function (_ref3) {
            var i = _ref3.i;
            return i === line.i;
          });

          var _this2$calcLineValues2 = _this2.calcLineValues({
            x: x,
            y: y
          }, target, compare, 'y'),
              length = _this2$calcLineValues2.length,
              origin = _this2$calcLineValues2.origin;

          line.length = length;
          line.origin = origin;
        });
      }

      this.setState({
        vLines: vLines,
        hLines: hLines,
        indices: indices
      });
      return {
        x: x,
        y: y
      };
    }
  }, {
    key: "calcLineValues",
    value: function calcLineValues(values, target, compare, key) {
      var x = values.x,
          y = values.y;
      var H = target.h,
          W = target.w;
      var l = compare.l,
          r = compare.r,
          t = compare.t,
          b = compare.b;
      var T = y,
          B = y + H,
          L = x,
          R = x + W;
      var direValues = {
        x: [t, b, T, B],
        y: [l, r, L, R]
      };
      var length = (0, _utils.getMaxDistance)(direValues[key]);
      var origin = Math.min.apply(Math, (0, _toConsumableArray2.default)(direValues[key]));
      return {
        length: length,
        origin: origin
      };
    }
  }, {
    key: "calcPosValues",
    value: function calcPosValues(values, target, compares, key) {
      var _this3 = this;

      var results = {};
      var directions = {
        x: ['ll', 'rr', 'lr', 'rl', 'mh'],
        y: ['tt', 'bb', 'tb', 'mv'] // filter unnecessary directions

      };
      var validDirections = directions[key].filter(function (dire) {
        return _this3.props.directions.includes(dire);
      });
      compares.forEach(function (compare) {
        validDirections.forEach(function (dire) {
          var _this3$calcPosValuesS = _this3.calcPosValuesSingle(values, dire, target, compare, key),
              near = _this3$calcPosValuesS.near,
              dist = _this3$calcPosValuesS.dist,
              value = _this3$calcPosValuesS.value,
              origin = _this3$calcPosValuesS.origin,
              length = _this3$calcPosValuesS.length;

          if (near) {
            (0, _utils.checkArrayWithPush)(results, dist, {
              i: compare.i,
              $: compare.$,
              value: value,
              origin: origin,
              length: length
            });
          }
        });
      });
      var resultArray = Object.entries(results);

      if (resultArray.length) {
        var _resultArray$sort$ = (0, _slicedToArray2.default)(resultArray.sort(function (_ref4, _ref5) {
          var _ref6 = (0, _slicedToArray2.default)(_ref4, 1),
              dist1 = _ref6[0];

          var _ref7 = (0, _slicedToArray2.default)(_ref5, 1),
              dist2 = _ref7[0];

          return Math.abs(dist1) - Math.abs(dist2);
        })[0], 2),
            minDistance = _resultArray$sort$[0],
            activeCompares = _resultArray$sort$[1];

        var dist = parseInt(minDistance);
        return {
          v: values[key] - dist,
          dist: dist,
          lines: activeCompares,
          indices: activeCompares.map(function (_ref8) {
            var i = _ref8.i;
            return i;
          })
        };
      }

      return {
        v: values[key],
        dist: 0,
        lines: [],
        indices: []
      };
    }
  }, {
    key: "calcPosValuesSingle",
    value: function calcPosValuesSingle(values, dire, target, compare, key) {
      var x = values.x,
          y = values.y;
      var W = target.w;
      var H = target.h;
      var l = compare.l,
          r = compare.r,
          t = compare.t,
          b = compare.b,
          lr = compare.lr,
          tb = compare.tb,
          xCompare = compare.x;

      var _this$calcLineValues = this.calcLineValues({
        x: x,
        y: y
      }, target, compare, key),
          origin = _this$calcLineValues.origin,
          length = _this$calcLineValues.length;

      var result = {
        // 距离是否达到吸附阈值
        // Whether the distance reaches the adsorption threshold
        near: false,
        // 距离差
        // Distance difference
        dist: Number.MAX_SAFE_INTEGER,
        // 辅助线坐标
        // Auxiliary line coordinates
        value: 0,
        // 辅助线长度
        length: length,
        // 辅助线起始坐标（对应绝对定位的top/left）
        // Starting coordinates of auxiliary line (corresponding to top/left of absolute positioning)
        origin: origin
      };

      switch (dire) {
        case 'lr':
          {
            var sides = [];
            sides.push({
              dist: x - r,
              value: r
            }); // right side

            sides.push({
              dist: x + W - xCompare,
              value: l
            }); // left side

            sides.forEach(function (side) {
              if (Math.abs(side.dist) < Math.abs(result.dist)) {
                result.dist = side.dist;
                result.value = side.value;
              }
            });
            break;
          }

        case 'll':
          result.dist = x - l;
          result.value = l;
          break;

        case 'rr':
          result.dist = x + W - r;
          result.value = r;
          break;

        case 'tt':
          result.dist = y - t;
          result.value = t;
          break;

        case 'bb':
          result.dist = y + H - b;
          result.value = b;
          break;

        case 'tb':
          {
            var _sides = [];

            _sides.push({
              dist: y + H - t,
              value: t
            }); // top side


            _sides.push({
              dist: y - b,
              value: b
            }); // bottom side


            _sides.forEach(function (side) {
              if (Math.abs(side.dist) < Math.abs(result.dist)) {
                result.dist = side.dist;
                result.value = side.value;
              }
            });

            break;
          }

        case 'mv':
          // middle vertical
          result.dist = y + H / 2 - tb;
          result.value = tb;
          break;

        case 'mh':
          // middle horizontal
          result.dist = x + W / 2 - lr;
          result.value = lr;
          break;
      }

      if (Math.abs(result.dist) < this.props.threshold + 1) {
        result.near = true;
      }

      return result;
    } // 检查是否拖出容器
    // Check if you drag out the container

  }, {
    key: "checkDragOut",
    value: function checkDragOut(_ref9, target) {
      var x = _ref9.x,
          y = _ref9.y;
      var maxLeft = this.$.clientWidth - target.w;
      var maxTop = this.$.clientHeight - target.h;
      var limitX = x;
      var limitY = y;

      if (x < 0) {
        limitX = 0;
      } else if (x > maxLeft) {
        limitX = maxLeft;
      }

      if (y < 0) {
        limitY = 0;
      }

      if (y > maxTop) {
        limitY = maxTop;
      }

      return {
        limitX: limitX,
        limitY: limitY
      };
    }
  }, {
    key: "_renderGuideLine",
    value: function _renderGuideLine() {
      var _this$state = this.state,
          vLines = _this$state.vLines,
          hLines = _this$state.hLines;
      var lineStyle = this.props.lineStyle;
      var commonStyle = (0, _objectSpread2.default)({
        position: 'absolute',
        backgroundColor: '#FF00CC'
      }, lineStyle); // support react 15

      var Container = _react.default.Fragment || 'div';
      return _react.default.createElement(Container, null, vLines.map(function (_ref10, i) {
        var length = _ref10.length,
            value = _ref10.value,
            origin = _ref10.origin;
        return _react.default.createElement("span", {
          className: "v-line",
          key: "v-".concat(i),
          style: (0, _objectSpread2.default)({
            left: value,
            top: origin,
            height: length,
            width: 1
          }, commonStyle)
        });
      }), hLines.map(function (_ref11, i) {
        var length = _ref11.length,
            value = _ref11.value,
            origin = _ref11.origin;
        return _react.default.createElement("span", {
          className: "h-line",
          key: "h-".concat(i),
          style: (0, _objectSpread2.default)({
            top: value,
            left: origin,
            width: length,
            height: 1
          }, commonStyle)
        });
      }));
    }
  }, {
    key: "_renderChildren",
    value: function _renderChildren() {
      var _this4 = this;

      var _this$props = this.props,
          activeClassName = _this$props.activeClassName,
          children = _this$props.children;
      var indices = this.state.indices;

      if (Array.isArray(children)) {
        return _react.default.createElement(_react.default.Fragment, null, children.map(function (child, index) {
          return _react.default.cloneElement(child, {
            _start: _this4.initialize,
            _drag: _this4.calc(index),
            _stop: _this4.reset,
            active: indices.includes(index),
            activeClassName: activeClassName
          });
        }));
      }

      return children;
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props2 = this.props,
          Container = _this$props2.Container,
          style = _this$props2.style;
      return _react.default.createElement(Container, {
        style: style,
        ref: function ref(_ref12) {
          return _this5.$ = _ref12;
        }
      }, this._renderChildren(), this._renderGuideLine());
    }
  }]);
  return DraggableContainer;
}(_react.default.Component);

exports.default = DraggableContainer;
(0, _defineProperty2.default)(DraggableContainer, "propTypes", {
  Container: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.element]),
  style: _propTypes.default.object,
  directions: _propTypes.default.array,
  threshold: _propTypes.default.number,
  className: _propTypes.default.string,
  activeClassName: _propTypes.default.string,
  limit: _propTypes.default.bool,
  lineStyle: _propTypes.default.object,
  detectOverlap: _propTypes.default.bool
});
(0, _defineProperty2.default)(DraggableContainer, "defaultProps", {
  Container: 'div',
  style: {},
  directions: ['tt', 'bb', 'll', 'rr', 'tb', 'lr', 'rl', 'mv', 'mh'],
  threshold: 5,
  className: '',
  activeClassName: 'active',
  limit: true,
  lineStyle: {},
  detectOverlap: false
});